package de.jottyfan.minecraft.quickiefabric.blockentity;

import de.jottyfan.minecraft.quickiefabric.blocks.QuickieBlocks;
import net.minecraft.block.BlockState;
import net.minecraft.block.Blocks;
import net.minecraft.block.entity.BlockEntity;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

/**
 * 
 * @author jotty
 *
 */
public class DrillBlockDownEntity extends BlockEntity {

	private static final Integer MAXDRILLSTEP = 20;
	private Integer drillstep;

	public DrillBlockDownEntity(BlockPos pos, BlockState state) {
		super(QuickieFabricBlockEntity.DRILL_DOWN, pos, state);
	}

	protected static final void moveBlockWithEntity(BlockPos from, BlockPos to, World world) {
		BlockEntity be = world.getBlockEntity(from);
		BlockState bs = world.getBlockState(from);
		if (be != null) {
			world.setBlockState(from, Blocks.AIR.getDefaultState());
			world.setBlockState(to, bs);
			world.removeBlockEntity(from);
			world.addBlockEntity(be);
		}
	}

	protected static final void drill(BlockPos pos, BlockPos to, World world) {
		if (!world.getBlockState(to).isOf(Blocks.BEDROCK) && !world.getBlockState(to).isOf(QuickieBlocks.DRILLSTOP)) {
			world.breakBlock(to, true);
			if (pos.down() != to) { // no need for the falling one
				moveBlockWithEntity(pos, to, world);
			}
		}
	}

	public static void tick(World world, BlockPos pos, BlockState state, BlockEntity be) {
		if (be instanceof DrillBlockDownEntity) {
			DrillBlockDownEntity dbde = (DrillBlockDownEntity) be;
			if (dbde.getDrillstep() < 1) {
				dbde.setDrillstep(MAXDRILLSTEP);
				drill(pos, pos.down(), world);
			} else {
				dbde.doDrillstep();
			}
		}
	}

	public void doDrillstep() {
		setDrillstep(getDrillstep() - 1);
	}

	public Integer getDrillstep() {
		return drillstep == null ? MAXDRILLSTEP : drillstep;
	}

	public void setDrillstep(Integer drillstep) {
		this.drillstep = drillstep;
	}
}
